#ifndef _CLISTCTRLEX_H_
#define _CLISTCTRLEX_H_

#include "TitleTip.h"
#include "CHeaderCtrlEx.h"

#define LVNU_SELCHANGED 0x1000

class CListCtrlEx : public CListCtrl
{
	typedef CListCtrl inherited;

	DECLARE_DYNCREATE(CListCtrlEx)

// Construction
public:
	CListCtrlEx();
	virtual ~CListCtrlEx();
    void DragColumn(int source, int dest);
    int GetColumnNumber( char *title );
    int HitTestEx(CPoint &point, int *col) const;
    
    BOOL SetItemText( int nItem, int nSubItem, CString lpszText );
    BOOL SetItemText( int nItem, int nSubItem, char *lpszText );

    int GetNColumns();
    CString GetColumnTitle( int n );

// Attributes
protected:
	CMyHeaderCtrl   m_headerctrl;
    BOOL m_bFullRowSel;
	BOOL m_bClientWidthSel;

    BOOL m_bDrawGrid;

	// For column sorting.
    int nSortedCol; 
    BOOL bSortAscending; 
    CToolTipCtrl m_tooltip;


public:
	BOOL SetFullRowSel(BOOL bFillRowSel);
	BOOL GetFullRowSel();
    void SetDrawGrid( BOOL bDrawGrid );
    BOOL GetDrawGrid();
    CEdit* EditSubLabel( int nItem, int nCol );

// Overrides
protected:
	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CListCtrlEx)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
    virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void PreSubclassWindow();
	//}}AFX_VIRTUAL

// Implementation
public:
#ifdef _DEBUG
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	void RepaintSelectedItems();

// Implementation - list view colors
	COLORREF m_clrText;
	COLORREF m_clrTextBk;
	COLORREF m_clrBkgnd;
	CTitleTip m_titletip;

	afx_msg LRESULT OnSetTextColor(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnSetTextBkColor(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnSetBkColor(WPARAM wParam, LPARAM lParam);

	bool HitTestRowCol(CPoint& point, int& iRow, int& iColumn)const;
	CRect GetCellRect(int iRow, int iColumn)const;

	int  GetTrueColumnWidth(int nCurrentPosition)const;
	CString GetTrueItemText(int row, int col)const;
	void HideTitleTip();
	void SendSelChangedNotification();
	void ShowTitleTip(CPoint point);
    void OnHeaderClicked(NMHDR* pNMHDR, LRESULT* pResult);
    BOOL SortTextItems( int nCol, BOOL bAscending, int low = 0, int high = -1);

// Generated message map functions
protected:
	//{{AFX_MSG(CListCtrlEx)
	afx_msg void OnPaint();
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnKillFocus(CWnd* pNewWnd);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnDestroy();
	afx_msg void OnEndlabeledit(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
#endif
