// WindowHideView.cpp : implementation of the CWindowHideView class
//

#include "stdafx.h"
#include "WindowHide.h"

#include "WindowHideDoc.h"
#include "WindowHideView.h"

#include "CustomizeDlg.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWindowHideView

IMPLEMENT_DYNCREATE(CWindowHideView, CFormView)

BEGIN_MESSAGE_MAP(CWindowHideView, CFormView)
	//{{AFX_MSG_MAP(CWindowHideView)
	ON_WM_SIZE()
	ON_COMMAND(ID_VIEW_REFRESH, OnViewRefresh)
	ON_NOTIFY(LVN_KEYDOWN, IDC_WINDOW_LIST, OnKeydownWindowList)
	ON_COMMAND(ID_EDIT_HIDE, OnEditHide)
	ON_COMMAND(ID_EDIT_SHOW, OnEditShow)
	ON_NOTIFY(LVNU_SELCHANGED, IDC_WINDOW_LIST, OnSelChanged)
	ON_COMMAND(ID_EDIT_TOGGLE, OnEditToggle)
	ON_COMMAND(ID_EDIT_CUSOMIIZE, OnEditCusomiize)
	ON_NOTIFY(NM_RCLICK, IDC_WINDOW_LIST, OnRclickWindowList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CWindowHideView construction/destruction

CWindowHideView::CWindowHideView()
	: CFormView(CWindowHideView::IDD)
{
	//{{AFX_DATA_INIT(CWindowHideView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// TODO: add construction code here

}

CWindowHideView::~CWindowHideView()
{
}

void CWindowHideView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWindowHideView)
	DDX_Control(pDX, IDC_WINDOW_LIST, m_listCtrl);
	//}}AFX_DATA_MAP
}

BOOL CWindowHideView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CWindowHideView diagnostics

#ifdef _DEBUG
void CWindowHideView::AssertValid() const
{
	CFormView::AssertValid();
}

void CWindowHideView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CWindowHideDoc* CWindowHideView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CWindowHideDoc)));
	return (CWindowHideDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CWindowHideView message handlers

void CWindowHideView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
    
    // Insert the header controls column headings
    m_listCtrl.InsertColumn( 0, "State" );
    m_listCtrl.InsertColumn( 1, "Title" );
    m_listCtrl.InsertColumn( 2, "Class Name" );
    m_listCtrl.InsertColumn( 3, "X co-ord" );
    m_listCtrl.InsertColumn( 4, "Y co-ord" );
    m_listCtrl.InsertColumn( 5, "Width" );
    m_listCtrl.InsertColumn( 6, "Height" );
  
    // Widen the headings of the four header columns.
    for (int i = 0; i < 7; i++ )
    { m_listCtrl.SetColumnWidth( i, 100 );
    }

    // Make the title column really wide.
    m_listCtrl.SetColumnWidth( 1, 300 );

    // Set the list control to use full row selection
    m_listCtrl.SetFullRowSel( 1 );
  
    AfxGetApp()->m_pMainWnd->SetWindowText( "Window Hide" );

    OnViewRefresh();
}

void CWindowHideView::OnSize(UINT nType, int cx, int cy) 
{
	CFormView::OnSize(nType, cx, cy);
	
    CRect l;

    // Ignore the first resize message
    if ( GetDlgItem( IDC_WINDOW_LIST ) == NULL )
        return;
    if ( GetDlgItem( IDC_WINDOW_LIST ) == NULL )
        return;

    UpdateData( FALSE );
    GetClientRect( &l );
    m_listCtrl.MoveWindow( l );
}

// Callback to populate the window.
// The EnumWindows() callback routine:  Gets the window's handle and the 
// class's this pointer
BOOL CALLBACK CWindowHideView::EnumCallback(HWND hWnd, LPARAM lParam)
{
   CWindowHideView *pThis = (CWindowHideView *)lParam;

   if ( pThis->m_state == ENUM )
   { // This saves window in list (if criteria is met)
     pThis->AddToList(hWnd);      
   }
   
   if ( pThis->m_state == SHOW )
   { 
     pThis->ShowWindow(hWnd);      
   }
 
   if ( pThis->m_state == HIDE )
   { 
     pThis->HideWindow(hWnd);      
   }
   if ( pThis->m_state == TOGGLE )
   { 
     pThis->ToggleWindow(hWnd);      
   }

   // Tell Windows to continue the enumeration
   return(TRUE);         
}


// Show the window, if the title, and classname are correct.
void CWindowHideView::ShowWindow( HWND hwnd )
{
  CString strTitle, strClassName;

  // Get the window's title 
  ::GetWindowText( hwnd, strTitle.GetBuffer( 500 ), 500 );
  strTitle.ReleaseBuffer();

  if ( strTitle.GetLength() < 1 )
    return;

  GetClassName( hwnd, strClassName.GetBuffer( 500 ), 500 );

  if ( ( strTitle == m_title ) &&
       ( strClassName == m_class ) )
  {
    ::ShowWindow( hwnd, SW_SHOWDEFAULT );
  }
}

// Toggle the always on top flag of a window.
void CWindowHideView::ToggleWindow( HWND hwnd )
{
  CString strTitle, strClassName;

  // Get the window's title 
  ::GetWindowText( hwnd, strTitle.GetBuffer( 500 ), 500 );
  strTitle.ReleaseBuffer();

  if ( strTitle.GetLength() < 1 )
    return;

  GetClassName( hwnd, strClassName.GetBuffer( 500 ), 500 );

  if ( ( strTitle == m_title ) &&
       ( strClassName == m_class ) )
  {
    // Bring the window to the front
    ::SetWindowPos( hwnd,
        ( GetWindowLong( hwnd, GWL_EXSTYLE ) & WS_EX_TOPMOST  ) ?
          HWND_NOTOPMOST:HWND_TOPMOST,
          0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE );
  }
}

// Hide the window, if the title, and classname are correct.
void CWindowHideView::HideWindow( HWND hwnd )
{
  CString strTitle, strClassName;

  // Get the window's title 
  ::GetWindowText( hwnd, strTitle.GetBuffer( 500 ), 500 );
  strTitle.ReleaseBuffer();

  if ( strTitle.GetLength() < 1 )
    return;

  GetClassName( hwnd, strClassName.GetBuffer( 500 ), 500 );

  if ( ( strTitle == m_title ) &&
       ( strClassName == m_class ) )
  {
    ::ShowWindow( hwnd, SW_HIDE );
  }
}

// Add the window specified to the list control
void CWindowHideView::AddToList( HWND hwnd )
{
  // Temporary holders for some values
  CString strState, strTitle, strClassName;
  CString strWindowWidth, strWindowHeight, strWindowPosX, strWindowPosY;

  // Get the window's title 
  ::GetWindowText( hwnd, strTitle.GetBuffer( 500 ), 500 );
  strTitle.ReleaseBuffer();

  // If the window title is empty then don't bother adding the window.
  if ( strTitle.GetLength() < 1 )
    return;

  // This shouldn't ever fail really.... Paranoia
  if ( !::IsWindow( hwnd ) )
    return;

  // See if the window is visible
  if ( ::IsWindowVisible( hwnd ) )
    strState = "Visible";
  else
    strState = "Hidden";

  // Get the class name
  GetClassName( hwnd, strClassName.GetBuffer( 500 ), 500 );

  // No title...display a default "untitled" string because we 
  // need a placeholder for this app because it is visible and
  // untitled, ooohhh, gross
  if(strTitle.IsEmpty())
    strTitle.LoadString(IDS_UNTITLED);
 

  // This stuff is irrelevant if the window is minimized... 
  if ( !::IsIconic( hwnd ) )
  { 
    CRect window;
    int wndWidth, wndHeight, wndX, wndY;

    ::GetWindowRect( hwnd, &window );

    wndWidth = window.Width();
    wndHeight = window.Height();
    sprintf( strWindowWidth.GetBuffer( 10 ), "%d", wndWidth );
    sprintf( strWindowHeight.GetBuffer( 10 ), "%d", wndHeight);

    wndX = window.left;
    wndY = window.top;
    sprintf( strWindowPosX.GetBuffer( 10 ), "%d", wndX );
    sprintf( strWindowPosY.GetBuffer( 10 ), "%d", wndY );
  }

  // Insert an item into the list, the GetColumnNumber stuff is necessary
  // because there is  the potential for the users to rearrange columns.
  // This would mean that we couldn't just insert the items into the list
  // in a fixed manner.
  int nItem = m_listCtrl.InsertItem(0, "" );
  m_listCtrl.SetItemText( nItem, m_listCtrl.GetColumnNumber( "Title" ) , strTitle );
  m_listCtrl.SetItemText( nItem, m_listCtrl.GetColumnNumber( "State" ), strState );
  m_listCtrl.SetItemText( nItem, m_listCtrl.GetColumnNumber( "Class Name" ), strClassName );
  m_listCtrl.SetItemText( nItem, m_listCtrl.GetColumnNumber( "Width" ), strWindowWidth );
  m_listCtrl.SetItemText( nItem, m_listCtrl.GetColumnNumber( "Height" ), strWindowHeight );
  m_listCtrl.SetItemText( nItem, m_listCtrl.GetColumnNumber( "X co-ord" ), strWindowPosX );
  m_listCtrl.SetItemText( nItem, m_listCtrl.GetColumnNumber( "Y co-ord" ), strWindowPosY );

}

// Called to refresh the list.
void CWindowHideView::OnViewRefresh() 
{

  // First clear the window list
  m_listCtrl.DeleteAllItems();

  m_state = ENUM;

  // Then run the callback
  ::EnumWindows(EnumCallback,(LPARAM)this);

  XStatusBar *bar = ((CMainFrame*)AfxGetMainWnd())->GetStatusBar();
  m_sStatusBarString.Format( "%d Entries", m_listCtrl.GetItemCount());

  bar->SetText( 0, m_sStatusBarString );

}

void CWindowHideView::OnKeydownWindowList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_KEYDOWN* pLVKeyDow = (LV_KEYDOWN*)pNMHDR;

    *pResult = 0;
    
    int i = m_listCtrl.GetNextItem( -1, LVNI_ALL | LVNI_SELECTED); 
    if ( i == -1 ) 
        return;

    m_title = m_listCtrl.GetItemText( i, m_listCtrl.GetColumnNumber( "Title" ) );
    m_class = m_listCtrl.GetItemText( i, m_listCtrl.GetColumnNumber( "Class" ) );

	if ( pLVKeyDow->wVKey == VK_DELETE )
      OnEditHide();
    else if ( pLVKeyDow->wVKey == VK_INSERT )
        OnEditShow();
	   
}

void CWindowHideView::OnEditHide() 
{
  m_state = HIDE;
  // Then run the callback
  ::EnumWindows(EnumCallback,(LPARAM)this);
}

void CWindowHideView::OnEditShow() 
{
  m_state = SHOW;
  // Then run the callback
  ::EnumWindows(EnumCallback,(LPARAM)this);
}

void CWindowHideView::OnEditToggle() 
{
  m_state = TOGGLE;
  // Then run the callback
  ::EnumWindows(EnumCallback,(LPARAM)this);
}	

void CWindowHideView::OnSelChanged(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_DISPINFO* pDispInfo = (LV_DISPINFO*)pNMHDR;

    DWORD dwPos = ::GetMessagePos();
    CPoint point ((int) LOWORD (dwPos), (int) HIWORD (dwPos));
    m_listCtrl.ScreenToClient( &point );

    int nIndex;
    if (( nIndex = m_listCtrl.HitTest (point )) == -1 )
    {  AfxMessageBox(" Error " );
       return;
    }

    m_title = m_listCtrl.GetItemText( nIndex, m_listCtrl.GetColumnNumber( "Title" ) );
    m_class = m_listCtrl.GetItemText( nIndex, m_listCtrl.GetColumnNumber( "Class Name" ) );
    *pResult = 0;
}



void CWindowHideView::OnEditCusomiize() 
{
    CCustomizeDlg dlg;

    // Build up an array of the current header columns.
    CStringArray current;
    int nColumns = m_listCtrl.GetNColumns();
    for( int i = 0; i < nColumns; i++ )
    {
        current.Add( m_listCtrl.GetColumnTitle( i ) );
    }
    // L3Enc - ED00A30F000009
    
    CStringArray poss;
    if ( !InArray( &current, "State" ) )
        poss.Add( "State" );

    if ( !InArray( &current, "Title" ) )
        poss.Add( "Title" );

    if ( !InArray( &current, "Class Name" ) )
        poss.Add( "Class Name" );

    if ( !InArray( &current, "X co-ord" ) )
        poss.Add( "X co-ord" );

    if ( !InArray( &current, "Y co-ord" ) )
        poss.Add( "Y co-ord" );

    if ( !InArray( &current, "Width" ) )
        poss.Add( "Width" );

    if ( !InArray( &current, "Height" ) )
        poss.Add( "Height" );

    dlg.SetCurrent( &current );
    dlg.SetAvailable( &poss );

    if ( dlg.DoModal() == IDOK )
    {
        // Remove all columns
        // Remove the first column repeatadly to ensure that
        // we don;t have to adjust the index of the removed column
        // as we iterate over them.
        int colcount = m_listCtrl.GetNColumns(); 
        for( int col = 0; col < colcount; col++)
            m_listCtrl.DeleteColumn( 0 );
        m_listCtrl.DeleteAllItems();    
    
        // Get the columns the user selected
        CStringArray *array = dlg.GetEntrys();

        // Add all the users columns
        int count = 0;
        count  = array->GetSize();
        for( int i = 0; i < count; i++ )
        {
            // Insert the header controls column headings
            m_listCtrl.InsertColumn( i, array->GetAt( i ) );
        }

        // Widen the headings of the header columns.
        for (i = 0; i < count; i++ )
        { m_listCtrl.SetColumnWidth( i, 125 );
        }

		OnViewRefresh();
    }

}

/**
  * Return true if the specified string is contained in the 
  * StringArray.
  */
BOOL CWindowHideView::InArray( CStringArray *a, CString str )
{
    int count = a->GetSize();
    for( int i = 0; i < count; i++ )
    {
        if ( str.Compare( a->GetAt( i ) ) == 0 ) 
            return( TRUE );
    }
    return FALSE;
}

void CWindowHideView::OnRclickWindowList(NMHDR* pNMHDR, LRESULT* pResult) 
{
   int nIndex = m_listCtrl.GetNextItem( -1, LVNI_ALL ); 
   if ( nIndex == -1 )
   {
      *pResult = 0;
      return;
   }

   // Get the point at which the message occured.
   DWORD dwPos = ::GetMessagePos();
   CPoint point ((int) LOWORD (dwPos), (int) HIWORD (dwPos));

   // Load the popup menu.
   CMenu menu;
   VERIFY( menu.LoadMenu( IDR_CONTEXT ) );

   CMenu* pMenu = menu.GetSubMenu( 0 );
   ASSERT(pMenu != NULL);
   CWnd* pWndPopupOwner = this;

   // Wait for the user to select something from the menu.
   DWORD SelectionMade = pMenu->TrackPopupMenu(
       TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_NONOTIFY | TPM_RETURNCMD,	point.x,point.y,this);

   // Process the menu selection
   switch ( SelectionMade )
   {
	  case ID_CONTEXT_SHOW:
		{  // Show the server properties
		   OnEditShow();
		}
        break;   
	  case ID_CONTEXT_HIDE:
		{  // Show the server properties
		   OnEditHide();
		}
        break;   
	  case ID_CONTEXT_TOGGLE:
		{  // Show the server properties
		   OnEditToggle();
		}
        break;   
      case ID_CONTEXT_CUSTOMIZE:
        {
            // Customize the header control
            OnEditCusomiize();
        }
        break;
	  default:
        break;
    }


	
	*pResult = 0;
}

void CWindowHideView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
 CStatusBar* pStatus = (CStatusBar*) AfxGetApp()->m_pMainWnd->GetDescendantWindow(AFX_IDW_STATUS_BAR);
 pStatus->SetPaneText(0, "Test Message");	
 pStatus->UpdateWindow();
	
}

