// WindowHideView.h : interface of the CWindowHideView class
//
/////////////////////////////////////////////////////////////////////////////
#include "ListCtrlEx.h"

#define ENUM    0
#define HIDE    1
#define SHOW    2
#define TOGGLE  3

#if !defined(AFX_WINDOWHIDEVIEW_H__1A4EFAEC_6E4E_11D2_8ED8_006008647170__INCLUDED_)
#define AFX_WINDOWHIDEVIEW_H__1A4EFAEC_6E4E_11D2_8ED8_006008647170__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CWindowHideView : public CFormView
{
protected: // create from serialization only
	CWindowHideView();
	DECLARE_DYNCREATE(CWindowHideView)
    
public:
	//{{AFX_DATA(CWindowHideView)
	enum { IDD = IDD_WINDOWHIDE_FORM };
	CListCtrlEx	m_listCtrl;
	//}}AFX_DATA

   // Called to refresh the window list.
   void Refresh();

   // Callback routine used by window enumeration
   static BOOL CALLBACK EnumCallback(HWND hWnd, LPARAM lParam);

   // Add a window to the list.
   void AddToList( HWND hwnd );
   void ShowWindow( HWND hwnd );
   void HideWindow( HWND hwnd );
   void ToggleWindow( HWND hwnd );

private:
	BOOL InArray( CStringArray *a, CString str );

private:
	int m_state;
	CString m_title;
	CString m_class;
	CString m_sStatusBarString;

// Attributes
public:
	CWindowHideDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWindowHideView)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CWindowHideView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CWindowHideView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnViewRefresh();
	afx_msg void OnKeydownWindowList(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnEditHide();
	afx_msg void OnEditShow();
	afx_msg void OnSelChanged(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnEditToggle();
	afx_msg void OnEditCusomiize();
	afx_msg void OnRclickWindowList(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in WindowHideView.cpp
inline CWindowHideDoc* CWindowHideView::GetDocument()
   { return (CWindowHideDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_WINDOWHIDEVIEW_H__1A4EFAEC_6E4E_11D2_8ED8_006008647170__INCLUDED_)
